
// Updated 2020 02 29

;( function( $ ) {

	function ua_TinyMCE_pulse($E, delay, duration, count) {
		$E.delay(delay).fadeTo(duration, 0.1).delay(delay).fadeTo(duration, 1.0, function () {
			if(count > 1) {
				count --;
				ua_TinyMCE_pulse($E, delay, duration, count);
			} else {
				$(this).show().css('opacity', '');

				if($(this).is('div, figure, table, tr, ul, ol')){

				} else {
					var $S = $('<span />').addClass('ua-tmp-wr').html($(this).html());
					$(this).html($S);
					tinyMCE.activeEditor.selection.select($S.get(0));
				}
			}
		});
	}
	
	function ua_TinyMCE_scroll(ed, elm, n){
		$(ed.dom.select('html, body')).stop().animate({ scrollTop: ($(n).offset().top) - 150 }, 500);
		ed.selection.select(n);
		return true;
	}
	
	function ua_TinyMCE_selector_getElement(ed, elm, action){
		return true;
	}
	
	function ua_TinyMCE_selector_returnElement(ed, elm, n){
		return true;
	}

  

	tinymce.PluginManager.add('ua_select', function( ed, url ) {
  
			ed.addButton('ua_select', {  
                title : ed.getLang('ua_select.ua_select_text') + ' - ' + ed.getLang('ua_select.ua_select_title'),
				text : ed.getLang('ua_select.ua_select_text'), 
				icon : 'fa ua-select',
				onclick : function() {  
					
					var $B = $(ed.getBody());
					$B.find('p:contains("_|_")').remove();
					var $E = $(ed.selection.getNode());
					
					if($E.is('.ua-tmp-wr')){
						$E = $E.parent();
						$E.find('.ua-tmp-wr').replaceWith($E.find('.ua-tmp-wr').html());
					}
					
					/* galleries and stuff */
					if($E.is('.wpview-wrap *')){
						$E = $E.closest('.wpview-wrap');
					}
					if($E.is('.mceTemp *')){
						$E = $E.closest('.mceTemp');
					}
					if($E.is('.wp-playlist *')){
						$E = $E.closest('.wp-playlist');
					}
					
					if($E.is('body')) return false;
					ua_TinyMCE_scroll(ed, $E.get(0), $E.get(0));
					ed.selection.select($E.get(0));
					return true;
                }
            });  
			ed.addButton('ua_remove', {  
                title : ed.getLang('ua_select.ua_remove_text') + ' - ' + 'Remove selected element',
				text : '', 
				icon : 'remove fa ua-remove',  
				onclick : function() {  
				
					ed.undoManager.add();
					
					var root;
					var allow = 'body, .mce-content-body, .ua-content';
					root = '.wpview-wrap, .mceTemp, .wp-playlist, h1, h2, h3, h4, h5, h6, p, a, li, ul, ol, th, td, tr, table, div, figure, blockquote';
					
					var $B = $(ed.getBody());
					var $E = $(ed.selection.getNode());
					var $S = $('<span />').addClass('ua-tmp-wr').text('_|_');
					var $N = $('<p />').append($S);
					
					if($E.is('body')) return false;

					if($E.is('.ua-tmp-wr')){
						$E = $E.closest(root);
						$E.find('.ua-tmp-wr').replaceWith($E.find('.ua-tmp-wr').html());
					}
					if($E.find('.ua-tmp-wr').get(0)){
						$E.find('.ua-tmp-wr').each(function(){
							var txt = $(this).html();
							$(this).replaceWith(txt);
						});
					} 
					
					/* galleries and stuff */
					if($E.is('.wpview-wrap *')){
						$E = $E.closest('.wpview-wrap');
					}
					if($E.is('.mceTemp *')){
						$E = $E.closest('.mceTemp');
					}
					if($E.is('.wp-playlist *')){
						$E = $E.closest('.wp-playlist');
					}
					if($E.is('blockquote *')){
						$E = $E.closest('blockquote');
					}
					
					if(!$E.is(root)){
						if($E.closest(root).get(0)){
							$E = $($E.closest(root).get(0));
							ed.selection.select($E.get(0));
						} else {
							alert('Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
							return false;
						}
					}
					
					if($E.find('[style]').get(0)){
						$E.find('[style]').replaceWith($E.find('[style]').html());
						$E.find('br').remove();
					}
					
					if(!$E.closest(allow).get(0)) return false;
					
					var remove = false;
					if($E.html() || $E.text()){
						if($E.text() == '_|_') remove = true;
					} else remove = true;

					if(remove){
						$E.remove();
						return true;
					} else {
						
						/* cleanup old marker nodes */
						$B.find('p:contains("_|_")').remove();
						
						/* span node in focus */
						/* Next removal will delete element */
						
						$E.html($S);
						ua_TinyMCE_scroll(ed, $E.get(0), $S.get(0));
						ed.selection.select($S.get(0));
						return true;
					}
					
					/* on fail */
					//alert('FAILED: Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
					return false;
                }  
            });
			ed.addButton('ua_restore', {  
                title : 'Restore removed element',
				text : 'Restore', 
				icon : false,  
				onclick : function() {  
					$(ed.getBody()).html($(ed.getBody()).data('ua_redo'));
					return true;
                }  
            });
			ed.addButton('ua_clone', {  
                title : ed.getLang('ua_select.ua_clone_text') + ' - ' + 'Clone selected element',
				text : '', 
				icon : 'copy',  
				onclick : function() {
					
					var root;
					var allow = 'body, .mce-content-body, .ua-content';
					root = '.wpview-wrap, .mceTemp, .wp-playlist, h1, h2, h3, h4, h5, h6, p, li, ul, ol, th, td, tr, table, div, figure, blockquote';
					
					var $B = $(ed.getBody());
					var $E = $(ed.selection.getNode());
					
					/* cleanup old marker nodes */
					$B.find('p:contains("_|_")').remove();
					
					if($E.is('body')) return false;
					
					if($E.is('.ua-tmp-wr')){
						$E = $E.closest(root);
						$E.find('.ua-tmp-wr').replaceWith($E.find('.ua-tmp-wr').html());
					}
					if($E.find('.ua-tmp-wr').get(0)){
						$E.find('.ua-tmp-wr').each(function(){
							var txt = $(this).html();
							$(this).replaceWith(txt);
						});
					}
					
					/* galleries and stuff */
					if($E.is('.wpview-wrap *')){
						$E = $E.closest('.wpview-wrap');
					}
					if($E.is('.mceTemp *')){
						$E = $E.closest('.mceTemp').get(0);
					}
					if($E.is('.wp-playlist *')){
						$E = $E.closest('.wp-playlist');
					}
					if($E.is('blockquote *')){
						$E = $E.closest('blockquote');
					}
					
					if(!$E.is(root)){
						if($E.closest(root).get(0)){
							$E = $($E.closest(root).get(0));
							ed.selection.select($E.get(0));
						} else {
							alert('Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
							return false;
						}
					}

					if($E.closest(allow).get(0)){
						if($E.children('span[style]').get(0)){
							$E.children('span[style]').replaceWith($E.children('span[style]').html());
						}
						$E = $E.clone().insertAfter($E);
						ua_TinyMCE_scroll(ed, $E.get(0), $E.get(0));
						ua_TinyMCE_pulse($E, 75, 10, 2);
						return true;
					} 
					
					/* on fail */
					//alert('FAILED: Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
					return false;
                }  
            });
			ed.addButton('ua_up', {  
                title : ed.getLang('ua_select.ua_move_up_text') + ' - ' + 'Move element up',
				text : '', 
				icon : 'arrowup',  
				onclick : function() {  
					
					var root;
					var allow = 'body, .mce-content-body, .ua-content';
					root = '.wpview-wrap, .mceTemp, .wp-playlist, h1, h2, h3, h4, h5, h6, p, li, ul, ol, tr, table, div, figure, blockquote';
					
					var $B = $(ed.getBody());
					var $E = $(ed.selection.getNode());
					if($E.is('body')) return false;

					if($E.is('.ua-tmp-wr')){
						$E = $E.closest(root);
						$E.find('.ua-tmp-wr').replaceWith($E.find('.ua-tmp-wr').html());
					}
					if($E.find('.ua-tmp-wr').get(0)){
						$E.find('.ua-tmp-wr').each(function(){
							var txt = $(this).html();
							$(this).replaceWith(txt);
						});
					}
					
					/* galleries and stuff */
					if($E.is('.wpview-wrap *')){
						$E = $E.closest('.wpview-wrap');
					}
					if($E.is('.mceTemp *')){
						$E = $E.closest('.mceTemp');
					}
					if($E.is('.wp-playlist *')){
						$E = $E.closest('.wp-playlist');
					}
					if($E.is('blockquote *')){
						$E = $E.closest('blockquote');
					}
					
					if(!$E.is(root)){
						if($E.closest(root).get(0)){
							$E = $($E.closest(root).get(0));
							ed.selection.select($E.get(0));
						} else {
							alert('Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
							return false;
						}
					}

					if($E.closest(allow).get(0)){
						
						/* cleanup Chrome browser nodes */
						if($E.children('span[style]').get(0)){
							$E.children('span[style]').replaceWith($E.children('span[style]').html());
						}
						$E.prev().before($E);
						ua_TinyMCE_scroll(ed, $E.get(0), $E.get(0));
						ua_TinyMCE_pulse($E, 75, 10, 2);
						return true;
					} 
					
					/* on fail */
					//alert('FAILED: Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
					return false;
                }  
            });
			ed.addButton('ua_down', {  
                title : ed.getLang('ua_select.ua_move_down_text') + ' - ' + 'Move element down',
				text : '', 
				icon : 'arrowdown',  
				onclick : function() {
					
					var root;
					var allow = 'body, .mce-content-body, .ua-content';
					root = '.wpview-wrap, .mceTemp, .wp-playlist, h1, h2, h3, h4, h5, h6, p, li, ul, ol, tr, table, div, figure, blockquote';
					
					var $B = $(ed.getBody());
					var $E = $(ed.selection.getNode());
					if($E.is('body')) return false;

					if($E.is('.ua-tmp-wr')){
						$E = $E.closest(root);
						$E.find('.ua-tmp-wr').replaceWith($E.find('.ua-tmp-wr').html());
					}
					if($E.find('.ua-tmp-wr').get(0)){
						$E.find('.ua-tmp-wr').each(function(){
							var txt = $(this).html();
							$(this).replaceWith(txt);
						});
					}
					
					/* galleries and stuff */
					if($E.is('.wpview-wrap *')){
						$E = $E.closest('.wpview-wrap'); 
					}
					if($E.is('.mceTemp *')){
						$E = $E.closest('.mceTemp');
					}
					if($E.is('.wp-playlist *')){
						$E = $E.closest('.wp-playlist');
					}
					if($E.is('blockquote *')){
						$E = $E.closest('blockquote');
					}
					
					if(!$E.is(root)){
						if($E.closest(root).get(0)){
							$E = $($E.closest(root).get(0));
							ed.selection.select($E.get(0));
						} else {
							alert('Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
							return false;
						}
					}

					if($E.closest(allow).get(0)){
						
						/* cleanup Chrome browser nodes */
						if($E.children('span[style]').get(0)){ alert('span');
							$E.children('span[style]').replaceWith($E.children('span[style]').html());
						}
						$E.next().after($E);
						ua_TinyMCE_scroll(ed, $E.get(0), $E.get(0));
						ua_TinyMCE_pulse($E, 75, 10, 2);
						return true;
					} 
					
					/* on fail */
					//alert('FAILED: Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
					return false;
                }  
            });
            ed.addButton('ua_before', {  
                title : ed.getLang('ua_select.ua_in_before_text') + ' - ' + 'Insert content before selection',
				text : ed.getLang('ua_select.ua_in_before_text'),
                icon : 'fa ua-before', 
                onclick : function() {  
					
					var root;
					var allow = 'body, .mce-content-body, .ua-content';
					root = '.wpview-wrap, .mceTemp, .wp-playlist, h1, h2, h3, h4, h5, h6, p, li, ul, ol, th, td, tr, thead, tbody, tfoot, table, div, figure';
					root = '.wpview-wrap, .mceTemp, .wp-playlist, h1, h2, h3, h4, h5, h6, p, ul, ol, table, div, figure, blockquote';
					
					var $B = $(ed.getBody());
					var $E = $(ed.selection.getNode());
					var $S = $('<span />').addClass('ua-tmp-wr').text('_|_');
					var $N = $('<p />').append($S);
					
					//?
					$B.find('.ua-mce-edit-image-wr').remove();

					if($E.is('.ua-tmp-wr')){
						$E = $E.closest(root);
						$E.find('.ua-tmp-wr').replaceWith($E.find('.ua-tmp-wr').html());
					}
					if($E.find('.ua-tmp-wr').get(0)){
						$E.find('.ua-tmp-wr').each(function(){
							var txt = $(this).html();
							$(this).replaceWith(txt);
						});
					}
					
					/* galleries and stuff */
					if($E.is('.wpview-wrap *')){
						$E = $E.closest('.wpview-wrap');
					}
					if($E.is('.mceTemp *')){
						$E = $E.closest('.mceTemp');
					}
					if($E.is('.wp-playlist *')){
						$E = $E.closest('.wp-playlist');
					}
					if($E.is('blockquote *')){
						$E = $E.closest('blockquote');
					}
					
					if(!$E.is('body') && !$E.is(root)){
						if($E.closest(root).get(0)){
							$E = $($E.closest(root).get(0));
							ed.selection.select($E.get(0));
						} else {
							alert('Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
							return false;
						}
					}

					/* cleanup old marker nodes */
					$B.find('p:contains("_|_")').remove();

					if($E.closest(allow).get(0)){
						if(!$E.is('body')){
							/* cleanup Chrome browser nodes */
							if($E.find('[style]').get(0)){
								$E.find('[style]').replaceWith($E.find('[style]').html());
								$E.find('br').remove();
							}
							$E.before($N);
						} else {
							$E.append($N);
						}
						
						/* span node in focus */
						/* New content in this node will carry the span until next cleanup */
						
						ua_TinyMCE_scroll(ed, $E.get(0), $S.get(0));
						ed.selection.select($S.get(0));
						
						return true;
					} 
					
					/* on fail */
					//alert('FAILED: Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
					return true;
  
                }  
            }); 
            ed.addButton('ua_after', {  
			
                title : ed.getLang('ua_select.ua_in_after_text') + ' - ' + 'Insert content after selection',
				text : ed.getLang('ua_select.ua_in_after_text'),
                icon : 'fa ua-after', 
                onclick : function() {  
					
					var root;
					var allow = 'body, .mce-content-body, .ua-content';
					root = '.wpview-wrap, .mceTemp, .wp-playlist, h1, h2, h3, h4, h5, h6, p, li, ul, ol, th, td, tr, thead, tbody, tfoot, table, div, figure';
					root = '.wpview-wrap, .mceTemp, .wp-playlist, h1, h2, h3, h4, h5, h6, p, ul, ol, table, div, figure, blockquote';
					
					var $B = $(ed.getBody());
					var $E = $(ed.selection.getNode());
					var $S = $('<span />').addClass('ua-tmp-wr').text('_|_');
					var $N = $('<p />').append($S);
					
					//?
					$B.find('.ua-mce-edit-image-wr').remove();

					if($E.is('.ua-tmp-wr')){
						$E = $E.closest(root);
						$E.find('.ua-tmp-wr').replaceWith($E.find('.ua-tmp-wr').html());
					}
					if($E.find('.ua-tmp-wr').get(0)){
						$E.find('.ua-tmp-wr').each(function(){
							var txt = $(this).html();
							$(this).replaceWith(txt);
						});
					}
					
					/* galleries and stuff */
					if($E.is('.wpview-wrap *')){
						$E = $E.closest('.wpview-wrap');
					}
					if($E.is('.mceTemp *')){
						$E = $E.closest('.mceTemp');
					}
					if($E.is('.wp-playlist *')){
						$E = $E.closest('.wp-playlist');
					}
					if($E.is('blockquote *')){
						$E = $E.closest('blockquote');
					}
					
					if(!$E.is('body') && !$E.is(root)){
						if($E.closest(root).get(0)){
							$E = $($E.closest(root).get(0));
							ed.selection.select($E.get(0));
						} else {
							alert('Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
							return false;
						}
					}
					
					if(!$E.is('body') && $E.parent().is('body')){
						if($E.next()) $E.after("&nbsp;");
					}
					
					/* cleanup old marker nodes */
					$B.find('p:contains("_|_")').remove();

					if($E.closest(allow).get(0)){
						if(!$E.is('body')){
							/* cleanup Chrome browser nodes */
							if($E.find('[style]').get(0)){
								$E.find('[style]').replaceWith($E.find('[style]').html());
								$E.find('br').remove();
							}
						
							$E.after($N);
						} else {
							$E.append($N);
						}
						
						/* span node in focus */
						/* New content in this node will carry the span until next cleanup */
						
						ua_TinyMCE_scroll(ed, $E.get(0), $S.get(0));
						ed.selection.select($S.get(0));
						
						return true;
					} 
					
					/* on fail */
					//alert('FAILED: Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
					return false;
				}  
			}); 
			ed.addButton('ua_clear', {  
				title : ed.getLang('ua_select.ua_in_clear_text') + ' - ' + 'Insert Clear float before selection',
				text : '',
				icon : 'nonbreaking',
				onpostrender: function(e) {  
					var btn = this;
					ed.on('NodeChange', function(e) {
						if($(e.element).hasClass('ua-clear')) btn.active(true);
							else btn.active(false);
					});
					
                },
				onclick : function() {  
				
					var root = '.wpview-wrap, .mceTemp, .wp-playlist, h1, h2, h3, h4, h5, h6, p, ul, ol, table, div, figure, blockquote';
					var $E = $(ed.selection.getNode());
					if($E.is('body')) return false;
					if($E.is('div.ua-clear')){
						if($E.next().get(0)) ed.selection.select($E.next().get(0));
						$E.remove();
						this.active(false);
						return false;
					}
					if($E.is('.ua-tmp-wr')){
						$E = $E.closest(root);
						$E.find('.ua-tmp-wr').replaceWith($E.find('.ua-tmp-wr').html());
					}
					if($E.find('.ua-tmp-wr').get(0)){
						$E.find('.ua-tmp-wr').each(function(){
							var txt = $(this).html();
							$(this).replaceWith(txt);
						});
					}
					
					$linebreak = $('<br />').addClass('wp-block-entex-clear').attr('data-clear', 'all');
					$clear = $('<div />').attr('data-type', 'entex/clear');
					$clear.append($linebreak);
					
					/* galleries and stuff */
					if($E.is('.wpview-wrap *')){
						$E = $E.closest('.wpview-wrap');
					}
					if($E.is('.mceTemp *')){
						$E = $E.closest('.mceTemp');
					}
					if($E.is('.wp-playlist *')){
						$E = $E.closest('.wp-playlist');
					}
					if($E.is('blockquote *')){
						$E = $E.closest('blockquote');
					}
					
					if(!$E.is(root)){
						if($E.closest(root).get(0)){
							$E = $($E.closest(root).get(0));
							ed.selection.select($E.get(0));
						} else {
							alert('Current node is not av valid selector: ' + ed.selection.getNode().nodeName);
							return false;
						}
					}
					
					/* add the element */
					$E.before($clear);
					
					$clear.toggleClass('ua-clear');
					if($clear.hasClass('ua-clear')) this.active(true);
						else this.active(false);
					return true;
                }  
            });
			
			ed.addButton('ua_marker', {  
				title : ed.getLang('ua_select.ua_in_marker_text') + ' - ' + 'Insert shortcode',
				text : '',
				icon : 'minus',
				onpostrender: function(e) {  
					var btn = this;
					ed.on('NodeChange', function(e) {
						if($(e.element).hasClass('ua-marker')) btn.active(true);
							else btn.active(false);
					});
					
                },
				onclick : function() { 
					var root = '.wpview-wrap, .mceTemp, .wp-playlist, h1, h2, h3, h4, h5, h6, p, ul, ol, table, div, figure, blockquote';
					var $E = $(ed.selection.getNode());
					
					if($E.is('.ua-tmp-wr')){
						$E = $E.closest(root);
						$E.find('.ua-tmp-wr').replaceWith($E.find('.ua-tmp-wr').html());
					}
					if($E.find('.ua-tmp-wr').get(0)){
						$E.find('.ua-tmp-wr').each(function(){
							var txt = $(this).html();
							$(this).replaceWith(txt);
						});
					}
					
					if(!$E.is('p')){
						if($E.closest('p').get(0)){
							$E = $($E.closest('p').get(0));
							ed.selection.select($E.get(0));
						} else {
							alert('Please use an empty paragraph for your marker (Use enter key to create an empty line)');
							return false;
						}
					}
					
					if($E.text() && !$E.hasClass('ua-marker')){
						alert('Please use an empty text element for your marker');
						return false;
					}
					var marker = prompt('Add custom marker replacement text. Leave empty to delete', 'entex-shortcode-post-thumbnail');
					if(!marker){
						$E.remove();
						this.active(false);
						return true;
					}

					$E.addClass('ua-marker').text('[' + marker.replace('[', '').replace(']', '') + ']');
					if($E.hasClass('ua-marker')) this.active(true);
						else this.active(false);
					return true;
                }  
            });
			

    });
})( jQuery );


