<?php if(!defined('ABSPATH')) die();

// Updated 2020 08 04

// POSTIE PLUGIN
/* Entex theme support for: postie */
/* Single functions, actions and filters */ 


/* -------------------- */
// RENAME ATTACHMENT TITLE
/* We dont wanna DC34983.JPG as title */
/* Lets steal the parent post title */


function entex_plugin_postie_post_update_attachments($post) {

    $post_id = $post['ID'];
	$obj = get_post($post_id);
	$title = $obj->post_title;
	//DebugEcho("ENTEX POST TITLE: ".$title, false);
	
	if(!$title) return $post;
	
	$images = get_children( array('post_parent' => $post_id, 'post_type' => 'attachment', 'post_mime_type' => 'image') );
	if($images){
		foreach( $images as $imageID => $imagePost ){
			//DebugEcho("ENTEX FOUND ATTACHMENT ID: ".$imageID, false);
			if($imageID){
				$attachment_title = get_the_title($imageID);
				//DebugEcho("ENTEX REPLACED TITLE: ". $attachment_title ." WITH: ".$title, false);
				wp_update_post(array(
					'ID' 			=> $imageID,
					'post_title' 	=> $title
				));
			}
		}
	}
    return $post;
}
add_action('postie_post_after', 'entex_plugin_postie_post_update_attachments', 20, 1);


// END : 
/* ******************** */

// -- END FILE -- //