<?php if(!defined('ABSPATH')) die();

// Updated 2021 06 10

// YOAST PLUGIN
/* Entex theme support for: Yoast SEO */
/* Single functions, actions and filters */ 



/* -------------------- */
// USE ENTEX EXCERPT SYSTEM

function entex_theme_add_wpseo_metadesc($metadesc){
	if(!$metadesc){
		if(is_singular()){
			add_filter('entex_theme_excerpt_indicate', 'entex_return_false', 30, 1);
			$metadesc = get_the_excerpt();
			remove_filter('entex_theme_excerpt_indicate', 'entex_return_false', 30, 1);
		}
	}
	/* wpautop might be applied by entex theme */
	return trim(strip_tags($metadesc));
}
add_filter('wpseo_metadesc', 'entex_theme_add_wpseo_metadesc', 30, 1);

/* -------------------- */
// OVERRIDE REPLACEMENTS 

function entex_theme_filter_wpseo_replacements($replacements){

	if(isset($replacements['%%excerpt%%'])){
		add_filter('entex_theme_excerpt_indicate', 'entex_return_false', 30, 1);
		$excerpt = get_the_excerpt();
		remove_filter('entex_theme_excerpt_indicate', 'entex_return_false', 30, 1);
		if($excerpt) $replacements['%%excerpt%%'] = $excerpt;
	}
	return $replacements;
}
add_filter('wpseo_replacements', 'entex_theme_filter_wpseo_replacements', 30, 1);

/* ******************** */






/* -------------------- */
// YOAST BREADCRUMBS 

function entex_theme_wp_seo_last_crumb($link_info, $index, $crumbs){

	if(is_front_page()){
		
		/* this does not affect schemas as it is not applied on startpage */
		/* translators: */
		$welcome = sprintf(_x('Welcome to %s', 'Breadcrumbs', 'entex'), entex_theme_fn_get_blogname());
	
		/* filter */ // return false to disable
		$welcome = apply_filters('entex_breadcrumbs_label_welcome', $welcome);
		if($welcome) $link_info['text'] = $welcome;
		
		return $link_info;
	}
	
	$n = 1;
	if(is_paged()){
		foreach($crumbs as $crumb){
			foreach($crumb as $key => $arr){
				if($key == 'hide_in_schema') $n++;
			}
		}
	}
	$last = (count($crumbs) - $n);
	
	/* This is the only way to target the closest parent crumb */
	if(isset($link_info['title'])) unset($link_info['title']);
	if($index == ($last - 1)) $link_info['title'] = _x('Closest level up', 'Breadcrumbs', 'entex');
	return $link_info;
}


function entex_theme_init_wp_seo_last_crumb(){
	add_filter('wpseo_breadcrumb_single_link_info', 'entex_theme_wp_seo_last_crumb', 10, 3);
}
add_action('after_setup_theme', 'entex_theme_init_wp_seo_last_crumb', 30, 1);


/* -------------------- */
// TEMPLATE BODY CLASS
function entex_theme_filter_body_class_wpseo($classes){
	if(defined('ENTEX_BREADCRUMBS_YOAST')) $classes[] = 'ua-crumbs-wpseo';
	if(defined('ENTEX_BREADCRUMBS_YOAST_SHOW_ALL')) $classes[] = 'ua-crumbs-wpseo-all';
	return $classes;
}
add_filter('body_class', 'entex_theme_filter_body_class_wpseo');

// END : YOAST BREADCRUMBS
/* ******************** */



// -- END FILE -- //